/****************************************************************************
 ARexx Skript zur automatischen Erzeugung von Thumbnails mit ADPro und
 anschliessender bername der Daten in DataBase.

 Dazu mu   - DataBase laufen und die 'picbase.db' Datei geladen sein
            - ADpro laufen

 Das ARexx Skript sollte durch das Skript 'PictureBase' aufgerufen werden.
 02.09.94, Jrg Richter
*****************************************************************************/

PARSE ARG argline
PARSE VAR argline path source bild length DB .
/*
   path   = Pfad fr das erzeugte Thumbnail
   source = Quellpfad der Bilder
   bild   = Pfad und Name des eigentlichenen Bildes
   length = Dateilnge des Bildes
   DB     = Pfad von Database
*/

OPTIONS RESULTS

RenderScreen = "Amiga 167936 640 256 256"  /* ADpro RenderScreen */
/*                    dispID  x   y  colors */

DIAsize = 120  /* Vorschaugre */
TempDefaults = "T:ADPro.defaults"  /* Datei mit Einstellungen von ADpro */

IF RIGHT(path,1) ~= "/" THEN DO
  IF RIGHT(path,1) ~= ":" THEN
    path = path || "/"
END

path = path || DelStr(bild,1,Length(source))

pos = MAX(LastPos("/",bild),LastPos(":",bild))+1
bildname = SubStr(bild,pos,Length(bild)-pos+1)    /* Bildname ermitteln */

path = SubStr(path,1,Length(path)-Length(bildname))

IF Exists(path || bildname) = 1 THEN /* Falls Thumbnail schon existiert */
  EXIT                           /* weiter mit nchsten Bild        */

ADDRESS DataBase
Message "Bearbeite " || bild || " ..."

ADDRESS "ADPro"

SAVE_DEFAULTS TempDefaults  /* aktuelle Einstellungen von ADpro sichern */

PSTATUS "LOCKED"  /* Feste Farbpalette bei allen Bildern */
DITHER 1          /* Floyd-Steinberg Dithering           */

LOADER "UNIVERSAL" bild  /* bergebendes Bild laden */
IF RC ~= 0 THEN EXIT     /* Abbruch falls Fehler    */
XSIZE
width = ADPRO_RESULT     /* Bildbreite und -hhe    */
YSIZE
height = ADPRO_RESULT

IF width > height THEN DO
  yy = (height/width) * DIAsize
  xx = DIAsize
  END
ELSE DO
  xx = (width/height) * DIAsize
  yy = DIAsize
  END

ABS_SCALE xx yy

SET_RENDER_MODE RenderScreen
EXECUTE  /* Bild in den Screen mit fester Farbpalette rendern */

SAVER "IFF" path || bildname "IMAGE"  /* Als 8 bit IFF in die Thumbnail */
                                      /* Schublade speichern            */
LOAD_DEFAULTS TempDefaults  /* Zurcksetzen der Einstellungen von ADpro */


ADDRESS DataBase

Add                                 /* neuen Datensatz hinzufgen          */
PutData $F1 bild                    /* Orginalbildname und -pfad in Feld 1 */
PutData $F2 length                  /* Dateilnge des Bildes in Feld 2     */
PutData $F3 width || "x" || height  /* Bildbreite und -hhe in Feld 3      */
IF Compare(UPPER(DB),UPPER(SubStr(path,1,Length(DB)))) = 0 THEN
  path = DelStr(path,1,Length(DB)+1)

PutData $F4 path || bildname        /* Pfad/Name des Thumbnails in Feld 4  */
                                    /* Falls der Pfad teilweise mit dem    */
                                    /* Pfad von DataBase bereinstimmt,    */
                                    /* wird dieser Teil vorher einfernt    */

